#include "stack.h++"
#include <stack>
#include <iostream>

int main() {
  typedef int V;
  typedef std::allocator<V> A;
  typedef cphstl::list_based_stack<V, A> R;
  typedef cphstl::stack<V, A, R> stack;
  typedef stack::iterator iterator;

  stack s;

  s.push(5);
  s.push(7);
  for(iterator it = s.begin(); it != s.end(); ++it) {
    std::cout << *it << std::endl;
  }

  std::stack<V, std::list<V> > t;
  t.push(5);
  t.push(7);
  std::stack<V, std::list<V> > tc(t);
  while(!tc.empty()) {
    std::cout << tc.top() << std::endl;  
    tc.pop();
  }
}
