#ifndef __CPHSTL_SET_HELPER__
#define __CPHSTL_SET_HELPER__

namespace cphstl {

  namespace unnamed {

    template <typename V>
    class identity {
    public:
      V operator()(V const& e) const {
	return e; 
      }
      V& operator()(V& e) const {
	return e; 
      }
    };

    template <typename K, typename V>
    class key_map {
    public:
      // static_assert: V == std::pair<K, X>
      K operator[](V const& e) const {
	return e.first; 
      }
    };
    
    template <typename K>
    class key_map<K, K> {
    public:
      K operator[](K const& k) const {
	return k; 
      }
    };

  }

}
#endif
