/* 

   Test program for the predefined vector classes. This is not a full test
   since the vector implementation is already tested using the smoke-test.
   This test is just testing the constructors.

   Author: Bo Simonsen, November 2009

*/

#include <cassert>
#include <memory> // defines std::allocator
#include "stl-predefined-vectors.h++"

template <typename V>
void test_members(V& v) {
  v.push_back(5);
  v.pop_back();
  v.push_back(7);
  v.clear();
}

#define create_vectors(x, n) x<int> v##n; \
  x<int> vv##n(100);\
  x<int> vvv##n(arr, arr+3);\
  x<int> vvvv##n(v##n);

int main() {
  int arr[] = {1,2,3};
  create_vectors(cphstl::fast_vector, 1)
  create_vectors(cphstl::safe_vector, 2)
  create_vectors(cphstl::compact_vector, 3)
  test_members(v1);
  v1 = vv1;
  test_members(v2);
  v2 = vv2;
  test_members(v3);
  v3 = vv3;
}
